﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel.Design;
using System.Collections;

namespace ExplorerBarLite
{
    [TypeConverter(typeof(ExplorerBarGroup)), DesignTimeVisible(false), ToolboxItem(false)]
    public partial class ExplorerBarGroup : UserControl
    {
        internal event EventHandler OnNewGroupSelection;
        internal ExplorerBar Control = null;
        private Panel containerControl;

        public ExplorerBarGroup()
        {
            InitializeComponent();
            Key = "New Group";
            explorerBarGroupHeader1.OnNewGroupSelection += new EventHandler(explorerBarGroupHeader1_OnNewGroupSelection);
        }

        [Browsable(false)]
        public ExplorerBar ExplorerBar { get; set; }

        public string Key
        {
            get
            {
                return explorerBarGroupHeader1.Key;
            }
            set
            {
                explorerBarGroupHeader1.Key = value;
            }
        }

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Visible), Browsable(false)]
        public Panel Container
        {
            get
            {
                if (pnlMain.Controls.Count > 0)
                {
                    return (Panel)pnlMain.Controls[0];
                }
                else
                {
                    return null;
                }
            }
            set
            {
                pnlMain.SuspendLayout();
                pnlMain.Controls.Clear();
                if (value != null)
                {
                    pnlMain.Controls.Add(value);
                    value.Dock = DockStyle.Fill;
                }
                pnlMain.ResumeLayout();
            }
        }

        //[DesignerSerializationVisibility(DesignerSerializationVisibility.Visible), Browsable(false)]
        //public Panel Container
        //{
        //    get
        //    {
        //        if ((this.containerControl == null))
        //        {
        //            //IDesignerHost designerHost = this.ExplorerBar.DesignerHost;
        //            //if (designerHost != null)
        //            //{
        //            //    this.containerControl = designerHost.CreateComponent(typeof(UltraExplorerBarContainerControl)) as UltraExplorerBarContainerControl;
        //            //}
        //            //else
        //            //{
        //            //    this.containerControl = new UltraExplorerBarContainerControl();
        //            //    if (((this.containerControl.Name.Length == 0) && (this.Key != null)) && (this.Key.Length > 0))
        //            //    {
        //            //        this.containerControl.Name = this.Key;
        //            //    }
        //            //}
        //            //this.containerControl.Resize += this.ContainerControlResizedEventHandler;
        //            //this.HookContainerControlEnterAndLeaveEvents();
        //            //this.containerControl.Initialize(this.ExplorerBar, this);
        //            //this.ExplorerBar.SetContainerVisibility(this.containerControl, true);
        //            //if (!this.ExplorerBar.IsNavigationPaneCollapsed)
        //            //{
        //            //    this.ExplorerBar.Controls.Add(this.containerControl);
        //            //}
        //        }
        //        return this.containerControl;
        //    }
        //    set
        //    {
        //        if (value != this.containerControl)
        //        {
        //            if (this.containerControl != null)
        //            {
        //                this.DestroyContainerControl();
        //            }
        //            this.containerControl = value;
        //            this.containerControl.Initialize(this.ExplorerBar, this);
        //            this.containerControl.Resize += this.ContainerControlResizedEventHandler;
        //            this.HookContainerControlEnterAndLeaveEvents();
        //        }
        //    }
        //}

        //public Panel ControlsPanel
        //{
        //    get
        //    {
        //        return pnlMain;
        //    }
        //}

        //[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
        //public ControlCollection Controls
        //{
        //    get
        //    {
        //        return pnlMain.Controls;
        //    }
        //}

        internal bool IsSelected
        {
            get
            {
                return explorerBarGroupHeader1.IsSelected;
            }
            set
            {
                explorerBarGroupHeader1.IsSelected = value;
            }
        }

        internal bool IsNewSelected
        {
            get
            {
                return explorerBarGroupHeader1.IsNewSelected;
            }
            set
            {
                explorerBarGroupHeader1.IsNewSelected = value;
            }
        }

        public void Select()
        {
            if (!this.IsSelected)
            {
                IsNewSelected = true;
                if (OnNewGroupSelection != null)
                    OnNewGroupSelection(this, null);
            }
        }

        void explorerBarGroupHeader1_OnNewGroupSelection(object sender, EventArgs e)
        {
            if (OnNewGroupSelection != null)
                OnNewGroupSelection(this, null);
        }
    }

    //public class ExplorerBarGroupCollection : CollectionBase
    //{
    //    private ExplorerBar Control;

    //    internal ExplorerBarGroupCollection(ExplorerBar Control)
    //    {
    //        this.Control = Control;
    //    }

    //    public ExplorerBarGroup this[int Index]
    //    {
    //        get
    //        {
    //            return (ExplorerBarGroup)List[Index];
    //        }
    //    }

    //    public bool Contains(ExplorerBarGroup group)
    //    {
    //        return List.Contains(group);
    //    }

    //    public int Add(ExplorerBarGroup group)
    //    {
    //        int i;

    //        i = List.Add(group);
    //        group.Control = Control;
    //        Control.CalculateLayout();

    //        return i;
    //    }

    //    public void Remove(ExplorerBarGroup group)
    //    {
    //        List.Remove(group);
    //        group.Control = null;
    //        Control.CalculateLayout();
    //    }
    //}
}
