﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel.Design;

namespace ExplorerBarLite
{
    [TypeConverter(typeof(ExplorerBarGroupHeader)), DesignTimeVisible(false), ToolboxItem(false)]
    public partial class ExplorerBarGroupHeader : UserControl
    {
        internal event EventHandler OnNewGroupSelection;
        private Color ColorNotSelected = Color.FromArgb(32, 77, 137);
        private Color ColorNotSelectedHover = Color.FromArgb(32, 77, 137);
        private Color ColorSelected = Color.Black;
        private Color ColorSelectedHover = Color.FromArgb(32, 77, 137);

        private bool isSelected = false;
        private bool isMouseOver = false;
        
        public ExplorerBarGroupHeader()
        {
            InitializeComponent();
        }

        public string Key
        {
            get
            {
                return lblName.Text;
            }
            set
            {
                lblName.Text = value;
            }
        }

        internal bool IsSelected
        {
            get
            {
                return isSelected;
            }
            set
            {
                isSelected = value;
                changeImageAndColor();
            }
        }

        internal bool IsNewSelected { get; set; }

        private void lblName_MouseEnter(object sender, EventArgs e)
        {
            isMouseOver = true;
            changeImageAndColor();
        }

        private void lblName_MouseLeave(object sender, EventArgs e)
        {
            isMouseOver = false;
            changeImageAndColor();
        }

        private void changeImageAndColor()
        {
            this.SuspendLayout();
            if (IsSelected)
            {
                if (isMouseOver)
                {
                    this.BackgroundImage = imageList1.Images["SelectedHover"];
                    lblName.ForeColor = ColorSelectedHover;
                }
                else
                {
                    this.BackgroundImage = imageList1.Images["Selected"];
                    lblName.ForeColor = ColorSelected;
                }
            }
            else
            {
                if (isMouseOver)
                {
                    this.BackgroundImage = imageList1.Images["NotSelectedHover"];
                    lblName.ForeColor = ColorNotSelectedHover;
                }
                else
                {
                    this.BackgroundImage = imageList1.Images["NotSelected"];
                    lblName.ForeColor = ColorNotSelected;
                }
            }
            this.ResumeLayout();
        }

        private void lblName_MouseDown(object sender, MouseEventArgs e)
        {
            this.SuspendLayout();
            if (isMouseOver)
            {
                this.BackgroundImage = imageList1.Images["SelectedHover"];
                lblName.ForeColor = ColorSelectedHover;
            }
            this.ResumeLayout();
        }

        private void lblName_MouseUp(object sender, MouseEventArgs e)
        {
            if (!IsSelected)
            {
                IsNewSelected = true;
                if (OnNewGroupSelection != null)
                    OnNewGroupSelection(null, null);
            }
        }
    }
}
