﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.IO;
using Unitronics.ComDriver;

namespace Unitronics.ComConfig.Lite.Presenters
{
    class ComConfigPresenter
    {
        private int m_SupportedChannels;

        public ComConfigPresenter()
        {
            SupportedChannels = (int)ComConfig.Channels.Serial | (int)ComConfig.Channels.Ethernet | (int)ComConfig.Channels.EthernetListener;

        }

        public PlcComConfig Load(string xmlFilePath)
        {
            PlcComConfig plcComConfig;
            using (FileStream fs = new FileStream(xmlFilePath, FileMode.Open))
            {
                XmlSerializer xs = new XmlSerializer(typeof(PlcComConfig));
                plcComConfig = (PlcComConfig)xs.Deserialize(fs);
            }
            return plcComConfig;
        }

        public void Save(string xmlFilePath, PlcComConfig plcComConfig)
        {
            using (FileStream fs = new FileStream(xmlFilePath, FileMode.Create))
            {
                XmlSerializer xs = new XmlSerializer(typeof(PlcComConfig));
                xs.Serialize(fs, plcComConfig);
            }
        }

        public int SupportedChannels
        {
            get
            {
                return m_SupportedChannels;
            }
            set
            {
                m_SupportedChannels = value;
            }
        }

        public List<ComConfig.Channels> SupportedChannelsList
        {
            get
            {
                List<ComConfig.Channels> result = new List<ComConfig.Channels>();
                if ((m_SupportedChannels & (int)ComConfig.Channels.Serial) != 0)
                    result.Add(ComConfig.Channels.Serial);

                if ((m_SupportedChannels & (int)ComConfig.Channels.Ethernet) != 0)
                    result.Add(ComConfig.Channels.Ethernet);

                if ((m_SupportedChannels & (int)ComConfig.Channels.EthernetListener) != 0)
                    result.Add(ComConfig.Channels.EthernetListener);

                return result;
            }
        }
    }
}
