﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Unitronics.ComDriver;

namespace Unitronics.ComConfig.Lite.Presenters
{
    class SerialPresenter
    {
        private Serial m_Serial;
        private PlcComConfig m_PlcComConfig;

        public SerialPresenter()
        {
            m_PlcComConfig = new PlcComConfig();
            m_Serial = (Serial)GetDefaultChannel();
            m_PlcComConfig.Channel = m_Serial;
        }

        public SerialPresenter(PlcComConfig plcComConfig)
        {
            m_PlcComConfig = plcComConfig;
            m_Serial = (Serial)plcComConfig.Channel;
        }

        public PlcComConfig PlcComConfig
        {
            get
            {
                return m_PlcComConfig;
            }
            set
            {
                m_PlcComConfig = value;
            }
        }

        public static Channel GetDefaultChannel()
        {
            Serial serial = new Serial(SerialPortNames.COM1, BaudRate.BR57600, 3, 1000, DataBits.DB8, System.IO.Ports.Parity.None, System.IO.Ports.StopBits.One);
            return serial;
        }
    }
}
